Overview | Package | Class | Deprecated | Index | Help
| Groovy Documentation
| FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | PROPERTY | CONSTR | METHOD | DETAIL: FIELD | PROPERTY | CONSTR | METHOD

## org.gradle.plugins.ide.idea.model
[Groovy] Class IdeaProject

    java.lang.Object
      org.gradle.plugins.ide.idea.model.IdeaProject

    class IdeaProject

Enables fine-tuning project details (*.ipr file) of the IDEA plugin.

Example of use with a blend of all possible properties. Typically you don't have configure IDEA module directly because Gradle configures it for you.

     import org.gradle.plugins.ide.idea.model.*

     apply plugin: 'java'
     apply plugin: 'idea'

     idea {
       project {
         //if you want to set specific jdk and language level
         jdkName = '1.6'
         languageLevel = '1.5'

         //you can update the source wildcards
         wildcards += '!?*.ruby'

         //you can change the modules of the the *.ipr
         //modules = project(':someProject').idea.module

         //you can change the output file
         outputFile = new File(outputFile.parentFile, 'someBetterName.ipr')

         //you can add project-level libraries
         projectLibraries << new ProjectLibrary(name: "my-library", classes: [new Path("path/to/library")])
       }
     }

For tackling edge cases users can perform advanced configuration on resulting XML file. It is also possible to affect the way IDEA plugin merges the existing configuration via beforeMerged and whenMerged closures.

beforeMerged and whenMerged closures receive Project object

Examples of advanced configuration:

     apply plugin: 'java'
     apply plugin: 'idea'

     idea {
       project {
         ipr {
           //you can tinker with the output *.ipr file before it's written out
           withXml {
             def node = it.asNode()
             node.appendNode('iLove', 'tinkering with the output *.ipr file!')
           }

           //closure executed after *.ipr content is loaded from existing file
           //but before gradle build information is merged
           beforeMerged { project ->
             //you can tinker with Project
           }

           //closure executed after *.ipr content is loaded from existing file
           //and after gradle build information is merged
           whenMerged { project ->
             //you can tinker with Project
           }
         }
       }
     }

Property Summary
`XmlFileContentMerger` | `ipr` See ipr(Closure)
`String` | `jdkName` The java version used for defining the project sdk.
`IdeaLanguageLevel` | `languageLevel` The java language level of the project.
`List` | `modules` A ConventionProperty that holds modules for the ipr file.
`File` | `outputFile` Output *.ipr
`PathFactory` | `pathFactory`
`Set` | `projectLibraries` The project-level libraries to be added to the IDEA project.
`Set` | `wildcards` The wildcard resource patterns.

Constructor Summary
`IdeaProject(XmlFileContentMerger ipr)`

Method Summary
`String` | `getName()` The name of the IDEA project.
`void` | `ipr(Closure closure)` Enables advanced configuration like tinkering with the output XML or affecting the way existing *.ipr content is merged with Gradle build information.
`void` | `mergeXmlProject(Project xmlProject)`
`void` | `setLanguageLevel(Object languageLevel)`

Methods inherited from class Object
wait, wait, wait, equals, toString, hashCode, getClass, notify, notifyAll

Property Detail

### ipr

    final XmlFileContentMerger ipr

  See ipr(Closure)

### jdkName

    String jdkName

  The java version used for defining the project sdk.

  See the examples in the docs for IdeaProject

### languageLevel

    IdeaLanguageLevel languageLevel

  The java language level of the project. Pass a valid Java version number (e.g. '1.5') or IDEA language level (e.g. 'JDK_1_5').

  See the examples in the docs for IdeaProject.

### modules

    List modules

  A ConventionProperty that holds modules for the ipr file.

  See the examples in the docs for IdeaProject

### outputFile

    File outputFile

  Output *.ipr

  See the examples in the docs for IdeaProject.

### pathFactory

    PathFactory pathFactory

### projectLibraries

    @Incubating
    Set projectLibraries

  The project-level libraries to be added to the IDEA project.

### wildcards

    Set wildcards

  The wildcard resource patterns.

  See the examples in the docs for IdeaProject.

Constructor Detail

### IdeaProject

    IdeaProject(XmlFileContentMerger ipr)

Method Detail

### getName

    String getName()

  The name of the IDEA project. It is a convenience property that returns the name of the output file (without the file extension). In IDEA, the project name is driven by the name of the 'ipr' file.

### ipr

    void ipr(Closure closure)

  Enables advanced configuration like tinkering with the output XML or affecting the way existing *.ipr content is merged with Gradle build information.

  See the examples in the docs for IdeaProject

### mergeXmlProject

    void mergeXmlProject(Project xmlProject)

### setLanguageLevel

    void setLanguageLevel(Object languageLevel)

Gradle API 1.10